// Attract-Mode display layout theme - DisplayView - By FrizzleFried with the help of plenty of people in the community!  Thank you!
// Visit my blog at www.idahogaragecade.com

// Layout options

local col = "White,Grey 50%,Grey 75%,Blue, Light Blue,Blue Green,Green,TMNT,Red,Ruby,Orange,Violet,Yellow Green,Yellow,Yellow Orange,Amber,";
local o=0;
local header = "● "
local headerend = "                                                                                                   " 

class UserConfig
{ 
</ label=header + "Skin" + headerend, help="Select your layout's skin.", options="Blank,Blue,Border Only,Brick,Diamondplate,Eye,Grid,Kombat,Logos,Pac,Retro,Retro Arcade,Shuffle & Slide", order=o++ /> skin="Blank";
</ label=header + "Toggle stars" + headerend, help="Toggle stars on/off.", options="On,Off", order=o++ /> starfield="On";
</ label=header + "Star speed" + headerend, help="Speed of starfield", options="Warp 10,Warp 5,Warp 1,Cruise,Crawl,Standing,Crawling Backwards,Cruising Backwards,Reverse Warp 1,Reverse Warp 5,Reverse Warp 10" order=o++ /> starspeed="Cruise";
</ label=header + "Games list type" + headerend, help="Select text or logos games list.", options="Logos,Text", order=o++ /> list_type="Logos";
</ label=header + "Text list color" + headerend, help="Color of text list.", options=col, order=o++ /> simple_color="white";
</ label=header + "Logo scroll direction" + headerend, help="Adjust logo scroll direction.", options="Left-Right,Up-Down", order=o++ /> preview_direction="Left-Right";
</ label=header + "Logo scroll speed" + headerend, help="Adjust logo scroll speed.", options="Fast,Medium,Slow", order=o++ /> preview_speed="Medium";
</ label=header + "Bottom text" + headerend, help="Text to display flashing at bottom of screen.", order=o++ /> msg2="Select Game List With Joystick";
</ label=header + "Bottom text color" + headerend, help="Color of the flashing text.", options=col, order=o++ /> pulse_color="Yellow";
</ label=header + "Monitor rotation" + headerend, help="Monitor rotation.",options="Horizontal,Vertical", order=o++ /> rotation="Horizontal";
}
local my_config = fe.get_config();

// General setup

fe.layout.width=640;
fe.layout.height=480;
local flx = fe.layout.width;
local fly = fe.layout.height;
local flw = fe.layout.width;
local flh = fe.layout.height;

// Set vertical orientation

if (my_config["rotation"] == "Vertical" )
{
	fe.layout.orient=RotateScreen.Right;
}

// Load modules

fe.load_module("animate");
fe.do_nut ( "scripts/carrier.nut" );
fe.do_nut ( "scripts/colors.nut" ); // Color.nut by Giacomo Bianchi 10/30/2018

// Starfield (speed change by guntherm)

if (my_config["starfield"] == "On" )
{
speed <- 0;
if (my_config["starspeed"] == "Warp 10" ) { speed=20; }
if (my_config["starspeed"] == "Warp 5" ) { speed=10; }
if (my_config["starspeed"] == "Warp 1" ) { speed=6; }
if (my_config["starspeed"] == "Cruise" ) { speed=3; }
if (my_config["starspeed"] == "Crawl" ) { speed=1; }
if (my_config["starspeed"] == "Standing" ) { speed=0; }
if (my_config["starspeed"] == "Crawling Backwards" ) { speed=-1; }
if (my_config["starspeed"] == "Cruising Backwards" ) { speed=-3; }
if (my_config["starspeed"] == "Reverse Warp 1" ) { speed=-6; }
if (my_config["starspeed"] == "Reverse Warp 5" ) { speed=-10; }
if (my_config["starspeed"] == "Reverse Warp 10" ) { speed=-15; }
fe.do_nut("scripts/star.nut");
}
	
// Scrolling logos w/background options

if (my_config["rotation"] == "Horizontal" )
{
	if (my_config["list_type"] == "Logos" )
	{
		if (my_config["preview_direction"] == "Left-Right" )
		{
			if (my_config["preview_speed"] == "Fast" )
			{
				local carrier = Carrier( flx*-0.570, fly*0.214, flw*2.150, flh*0.423, 5, 2, 30, 0, 0 )
				carrier.surfacePosSmoothing = 0.70
			}
			if (my_config["preview_speed"] == "Medium" )
			{
				local carrier = Carrier( flx*-0.575, fly*0.214, flw*2.150, flh*0.423, 5, 2, 30, 0, 0 )
				carrier.surfacePosSmoothing = 0.85
			}
			if (my_config["preview_speed"] == "Slow" )
			{
				local carrier = Carrier( flx*-0.575, fly*0.214, flw*2.000, flh*0.423, 5, 2, 30, 0, 0 )
				carrier.surfacePosSmoothing = 0.92
			}
		if (my_config["skin"] == "Border Only" ) { fe.add_image( "backgrounds/background4.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Diamondplate" ) { fe.add_image( "backgrounds/background4_2.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Shuffle & Slide" ) { fe.add_image( "backgrounds/background4_3.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro" ) { fe.add_image( "backgrounds/background4_4.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro Arcade" ) { fe.add_image( "backgrounds/background4_5.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Brick" ) { fe.add_image( "backgrounds/background4_6.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Grid" ) { fe.add_image( "backgrounds/background4_7.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blank" ) { fe.add_image( "backgrounds/background4_8.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blue" ) { fe.add_image( "backgrounds/background4_9.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Logos" ) { fe.add_image( "backgrounds/background4_10.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Kombat" ) { fe.add_image( "backgrounds/background4_11.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Pac" ) { fe.add_image( "backgrounds/background4_12.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Eye" ) { fe.add_image( "backgrounds/background4_13.png", 0, 0, flw*1.00, fly*1.00 ); }
		}
		if (my_config["preview_direction"] == "Up-Down" )
		{
			if (my_config["preview_speed"] == "Fast" )
			{
				local carrier = Carrier(flx*0.207, fly*-0.595, flh*0.780, flw*1.625, 9, 3, 25, 0, 0 )
				carrier.surfacePosSmoothing = 0.70
			}
			if (my_config["preview_speed"] == "Medium" )
			{
				local carrier = Carrier(flx*0.207, fly*-0.595, flh*0.780, flw*1.625, 9, 3, 25, 0, 0 )
				carrier.surfacePosSmoothing = 0.85
			}
			if (my_config["preview_speed"] == "Slow" )
			{
				local carrier = Carrier(flx*0.207, fly*-0.595, flh*0.780, flw*1.625, 9, 3, 25, 0, 0 )
				carrier.surfacePosSmoothing = 0.92
			}
		if (my_config["skin"] == "Border Only" ) { fe.add_image( "backgrounds/background3.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Diamondplate" ) { fe.add_image( "backgrounds/background3_2.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Shuffle & Slide" ) { fe.add_image( "backgrounds/background3_3.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro" ) { fe.add_image( "backgrounds/background3_4.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro Arcade" ) { fe.add_image( "backgrounds/background3_5.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Brick" ) { fe.add_image( "backgrounds/background3_6.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Grid" ) { fe.add_image( "backgrounds/background3_7.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blank" ) { fe.add_image( "backgrounds/background3_8.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blue" ) { fe.add_image( "backgrounds/background3_9.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Logos" ) { fe.add_image( "backgrounds/background3_10.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Kombat" ) { fe.add_image( "backgrounds/background3_11.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Pac" ) { fe.add_image( "backgrounds/background3_12.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Eye" ) { fe.add_image( "backgrounds/background3_13.png", 0, 0, flw*1.00, fly*1.00 ); }
		}
	}
	if (my_config["list_type"] == "Text" )
	{
		local lb = fe.add_listbox( flx*0.260, fly*0.020, flw*0.478, flh*0.942 );
		lb.charsize = 19;
		lb.rows = 15;
		colors( lb, my_config["simple_color"], 0 );
		lb.set_sel_rgb( 255, 255, 0 );
		lb.set_selbg_rgb( 45, 64, 154 );
		lb.selbg_alpha = 0
		lb.font = "captain";
	
		if (my_config["skin"] == "Border Only" ) { fe.add_image( "backgrounds/background3.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Diamondplate" ) { fe.add_image( "backgrounds/background3_2.png", 0, 0, flw*1.00, fly*1.00); }
		if (my_config["skin"] == "Shuffle & Slide" ) { fe.add_image( "backgrounds/background3_3.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro" ) { fe.add_image( "backgrounds/background3_4.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro Arcade" ) { fe.add_image( "backgrounds/background3_5.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Brick" ) { fe.add_image( "backgrounds/background3_6.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Grid" ) { fe.add_image( "backgrounds/background3_7.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blank" ) { fe.add_image( "backgrounds/background3_8.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blue" ) { fe.add_image( "backgrounds/background3_9.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Logos" ) { fe.add_image( "backgrounds/background3_10.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Kombat" ) { fe.add_image( "backgrounds/background3_11.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Pac" ) { fe.add_image( "backgrounds/background3_12.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Eye" ) { fe.add_image( "backgrounds/background3_13.png", 0, 0, flw*1.00, fly*1.00 ); }
	}
}	
	
if (my_config["rotation"] == "Vertical" )
{
	if (my_config["list_type"] == "Logos" )
	{
		if (my_config["preview_direction"] == "Left-Right" )
		{
			if (my_config["preview_speed"] == "Fast" )
			{
				local carrier = Carrier( flx*-0.500, fly*0.215, flw*2.000, flh*0.423, 5, 2, 25, 0, 0 )
				carrier.surfacePosSmoothing = 0.70
			}
			if (my_config["preview_speed"] == "Medium" )
			{
				local carrier = Carrier( flx*-0.500, fly*0.215, flw*2.000, flh*0.423, 5, 2, 25, 0, 0 )
				carrier.surfacePosSmoothing = 0.85
			}
			if (my_config["preview_speed"] == "Slow" )
			{
				local carrier = Carrier( flx*-0.500, fly*0.215, flw*2.000, flh*0.423, 5, 2, 25, 0, 0 )
				carrier.surfacePosSmoothing = 0.92
			}
		if (my_config["skin"] == "Border Only" ) { fe.add_image( "backgrounds/background2.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Diamondplate" ) { fe.add_image( "backgrounds/background2_2.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Shuffle & Slide" ) { fe.add_image( "backgrounds/background2_3.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro" ) { fe.add_image( "backgrounds/background2_4.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro Arcade" ) { fe.add_image( "backgrounds/background2_5.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Brick" ) { fe.add_image( "backgrounds/background2_6.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Grid" ) { fe.add_image( "backgrounds/background2_7.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blank" ) { fe.add_image( "backgrounds/background2_8.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blue" ) { fe.add_image( "backgrounds/background2_9.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Logos" ) { fe.add_image( "backgrounds/background2_10.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Kombat" ) { fe.add_image( "backgrounds/background2_11.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Pac" ) { fe.add_image( "backgrounds/background2_12.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Eye" ) { fe.add_image( "backgrounds/background2_13.png", 0, 0, flw*1.00, fly*1.00 ); }
		}

		if (my_config["preview_direction"] == "Up-Down" )
		{	
			if (my_config["preview_speed"] == "Fast" )
			{
				local carrier = Carrier(flx*0.207, fly*-0.165, flw*0.580, flh*1.300, 9, 2, 7, 0, 0 )
				carrier.surfacePosSmoothing = 0.70
			}
			if (my_config["preview_speed"] == "Medium" )
			{
				local carrier = Carrier(flx*0.207, fly*-0.165, flw*0.580, flh*1.300, 9, 2, 7, 0, 0 )
				carrier.surfacePosSmoothing = 0.85
			}
			if (my_config["preview_speed"] == "Slow" )
			{
				local carrier = Carrier(flx*0.207, fly*-0.165, flw*0.580, flh*1.300, 9, 2, 7, 0, 0 )
				carrier.surfacePosSmoothing = 0.92
			}
		if (my_config["skin"] == "Border Only" ) { fe.add_image( "backgrounds/background.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Diamondplate" ) { fe.add_image( "backgrounds/background_2.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Shuffle & Slide" ) { fe.add_image( "backgrounds/background_3.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro" ) { fe.add_image( "backgrounds/background_4.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro Arcade" ) { fe.add_image( "backgrounds/background_5.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Brick" ) { fe.add_image( "backgrounds/background_6.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Grid" ) { fe.add_image( "backgrounds/background_7.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blank" ) { fe.add_image( "backgrounds/background_8.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blue" ) { fe.add_image( "backgrounds/background_9.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Logos" ) { fe.add_image( "backgrounds/background_10.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Kombat" ) { fe.add_image( "backgrounds/background_11.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Pac" ) { fe.add_image( "backgrounds/background_12.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Eye" ) { fe.add_image( "backgrounds/background_13.png", 0, 0, flw*1.00, fly*1.00 ); }
		}
	}
	if (my_config["list_type"] == "Text" )
	{
		local lb = fe.add_listbox( flx*0.260, fly*0.020, flw*0.478, flh*0.942 );
		lb.charsize = 19;
		lb.rows = 15;
		colors( lb, my_config["simple_color"], 0 );
		lb.set_sel_rgb( 255, 255, 0 );
		lb.set_selbg_rgb( 45, 64, 154 );
		lb.selbg_alpha = 0
		lb.font = "captain";

		if (my_config["skin"] == "Border Only" ) { fe.add_image( "backgrounds/background.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Diamondplate" ) { fe.add_image( "backgrounds/background_2.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Shuffle & Slide" ) { fe.add_image( "backgrounds/background_3.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro" ) { fe.add_image( "backgrounds/background_4.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Retro Arcade" ) { fe.add_image( "backgrounds/background_5.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Brick" ) { fe.add_image( "backgrounds/background_6.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Grid" ) { fe.add_image( "backgrounds/background_7.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blank" ) { fe.add_image( "backgrounds/background_8.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Blue" ) { fe.add_image( "backgrounds/background_9.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Logos" ) { fe.add_image( "backgrounds/background_10.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Kombat" ) { fe.add_image( "backgrounds/background_11.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Pac" ) { fe.add_image( "backgrounds/background_12.png", 0, 0, flw*1.00, fly*1.00 ); }
		if (my_config["skin"] == "Eye" ) { fe.add_image( "backgrounds/background_13.png", 0, 0, flw*1.00, fly*1.00 ); }
	}
}

// Text bit

local pulse = fe.add_text( my_config["msg2"], flx*0.003, fly*0.929, flw*1.000, flh*0.050 );
	local pulse_text_cfg = {
		when =Transition.ToNewList,
		property = "alpha",
		start = 0, 
		end = 150,
		time = 1000,
		tween = Tween.Quad,
		pulse = true,
		font = "captain",
	}
	animation.add( PropertyAnimation( pulse, pulse_text_cfg ) );
	pulse.font = "captain";
	pulse.charsize = 20;
	pulse.alpha= 255;
	pulse.set_rgb ( 0 , 0 , 0 );

local pulse = fe.add_text( my_config["msg2"], flx*0.000, fly*0.925, flw*1.000, flh*0.050 );
	local pulse_text_cfg = {
		when =Transition.ToNewList,
		property = "alpha",
		start = 90, 
		end = 255,
		time = 1000,
		tween = Tween.Quad,
		pulse = true,
		font = "captain",
	}
	animation.add( PropertyAnimation( pulse, pulse_text_cfg ) );
	pulse.font = "captain";
	pulse.charsize = 20;
	pulse.alpha= 255;
	colors( pulse, my_config["pulse_color"], 0 );

// Game select sound

function select_sound( ttype, var, ttime ) {
 switch ( ttype ) {
	case Transition.ToNewSelection:
	      local sound = fe.add_sound("scripts/tick.mp3");
	      sound.playing=true;
	break;
	}
	return false;
}
fe.add_transition_callback( "select_sound" );